// -*- C++ -*- //

#ifndef MAPSELECTOR_H
#define MAPSELECTOR_H

class MapSelector;

#include <all_include.h>
#include <map_win.h>
#include <libgnomecanvasmm.h>
#include <libgnomecanvasmm/polygon.h>

class MapSelector : public Gtk::HBox
{
 protected:
  sigc::signal<void, std::string> signal_cbt;
  sigc::signal<void, bool> signal_newmapwin;

  bool def;

  bool itisedge;

  bool default_state;

  bool set_new_map;

  Gtk::ComboBoxText cbt;

  Gtk::Button * newbut, * defbut;

  Gtk::HBox hbox;

  Gtk::Label * label;

 public:

  MapSelector(std::vector<std::string>, std::string, std::string, bool, bool def=true);

  sigc::signal<void, std::string> signal_cbt_ch();
  sigc::signal<void, bool> signal_newmapwin_needed();

  void update_list( std::vector<std::string> );

  ///If a radiobutton is clicked, this function determines
  ///which button was that and after that calls the
  ///appropriate function of the \ref GraphDisplayerCanvas
  ///to change the visible values of that attribute.
  virtual void comboChanged();

  virtual void new_but_pressed();

  virtual void reset();

  Glib::ustring get_active_text();
  void set_active_text(Glib::ustring);
  void set_active(int index){cbt.set_active(index);};
  void clear(){cbt.clear();};
  void append_text(Glib::ustring);
};
#endif //MAPSELECTOR_H
